#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

long long gcd(long long a, long long b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

vector <long long> divisors(long long n) {
    vector <long long> ans;

    for (long long i = 1; i * i <= n; i++) {
        if (n % i == 0) {
            ans.push_back(i);
            if (n != i * i) ans.push_back(n / i);
        }
    }

    sort(ans.begin(), ans.end());
    return ans;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    long long n, m, h, v;
    cin >> n >> m >> h >> v;

    vector <long long> numbers = divisors(gcd(n, m));
    cout << numbers.size() << endl;
    cout << numbers.front();

    for (int i = 1; i < numbers.size(); i++) {
        cout << ' ' << numbers[i];
    }

    cout << endl;

    return 0;

}
